"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.commentNode = exports.slotScopeNode = exports.namedSlotAttributeNode = exports.slotNode = exports.isTemplateNode = exports.templateNode = exports.textNode = exports.classAttributeNode = exports.styleAttributeNode = exports.refAttributeNode = exports.eventAttributeNode = exports.makeUnSupportAttributeNode = exports.attributeNode = exports.isUseTemplateNode = exports.useTemplateNode = exports.elseElementNode = exports.elseIfElementNode = exports.ifElementNode = exports.forElementNode = exports.blockNode = exports.isElementNode = exports.elementNode = exports.includeNode = exports.importSJSNode = exports.importNode = exports.isFragmentNode = exports.fragmentNode = exports.dataBindingNode = exports.document = void 0;
const index_1 = __importDefault(require("./data-binding/index"));
function document(imports, templates, fragment) {
    return {
        type: 'Document',
        imports,
        templates,
        fragment
    };
}
exports.document = document;
function dataBindingNode(express) {
    return new index_1.default(express);
}
exports.dataBindingNode = dataBindingNode;
function fragmentNode(body) {
    return {
        type: 'FragmentNode',
        body
    };
}
exports.fragmentNode = fragmentNode;
function isFragmentNode(node) {
    return node.type === 'FragmentNode';
}
exports.isFragmentNode = isFragmentNode;
function importNode(src, name, from) {
    return {
        type: 'ImportNode',
        src,
        name,
        from
    };
}
exports.importNode = importNode;
function importSJSNode(name, from) {
    return {
        type: 'ImportSJSNode',
        name,
        from
    };
}
exports.importSJSNode = importSJSNode;
function includeNode(src) {
    return {
        type: 'IncludeNode',
        src
    };
}
exports.includeNode = includeNode;
function elementNode(name, nodeId, attributes = [], children = []) {
    return {
        type: 'ElementNode',
        name,
        attributes,
        children,
        nodeId
    };
}
exports.elementNode = elementNode;
function isElementNode(node) {
    return node.type === 'ElementNode';
}
exports.isElementNode = isElementNode;
function blockNode(children = [], attributes = []) {
    return {
        type: 'BlockNode',
        children,
        attributes
    };
}
exports.blockNode = blockNode;
function forElementNode(expresion, element) {
    return {
        type: 'ForElementNode',
        expresion,
        element
    };
}
exports.forElementNode = forElementNode;
function ifElementNode(expresion, ifElement) {
    return {
        type: 'IfElementNode',
        expresion,
        ifElement,
        elseIfElements: []
    };
}
exports.ifElementNode = ifElementNode;
function elseIfElementNode(expresion, element) {
    return {
        type: 'ElseIfElementNode',
        expresion,
        element
    };
}
exports.elseIfElementNode = elseIfElementNode;
function elseElementNode(element) {
    return {
        type: 'ElseElementNode',
        element
    };
}
exports.elseElementNode = elseElementNode;
function useTemplateNode(templateName, dataExpression) {
    return {
        type: 'UseTemplateNode',
        templateName,
        dataExpression
    };
}
exports.useTemplateNode = useTemplateNode;
function isUseTemplateNode(node) {
    return node.type === 'UseTemplateNode';
}
exports.isUseTemplateNode = isUseTemplateNode;
function attributeNode(name, value) {
    return {
        type: 'AttributeNode',
        name,
        value
    };
}
exports.attributeNode = attributeNode;
function makeUnSupportAttributeNode(name, value) {
    return {
        type: 'UnSupportAttributeNode',
        name,
        value
    };
}
exports.makeUnSupportAttributeNode = makeUnSupportAttributeNode;
function eventAttributeNode(name, value, isCatch = false) {
    return {
        type: 'EventAttributeNode',
        name,
        value,
        isCatch
    };
}
exports.eventAttributeNode = eventAttributeNode;
function refAttributeNode(value) {
    return {
        type: 'RefAttributeNode',
        value
    };
}
exports.refAttributeNode = refAttributeNode;
function styleAttributeNode(value) {
    return {
        type: 'StyleAttributeNode',
        value
    };
}
exports.styleAttributeNode = styleAttributeNode;
function classAttributeNode(value) {
    return {
        type: 'ClassAttributeNode',
        value
    };
}
exports.classAttributeNode = classAttributeNode;
function textNode(text) {
    return {
        type: 'TextNode',
        text
    };
}
exports.textNode = textNode;
function templateNode(name, fragment) {
    return {
        type: 'TemplateNode',
        name,
        fragment
    };
}
exports.templateNode = templateNode;
function isTemplateNode(node) {
    return node.type === 'TemplateNode';
}
exports.isTemplateNode = isTemplateNode;
function slotNode(children, attributes, name) {
    return {
        type: 'SlotNode',
        name,
        attributes,
        children
    };
}
exports.slotNode = slotNode;
function namedSlotAttributeNode(name) {
    return {
        type: 'NamedSlotAttributeNode',
        name
    };
}
exports.namedSlotAttributeNode = namedSlotAttributeNode;
function slotScopeNode(value, element, slot) {
    return {
        type: 'SlotScopeNode',
        value,
        element,
        slot
    };
}
exports.slotScopeNode = slotScopeNode;
function commentNode(comment) {
    return {
        type: 'CommentNode',
        comment
    };
}
exports.commentNode = commentNode;
//# sourceMappingURL=types.js.map