"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@morjs/utils");
const option_1 = require("../../../option");
const helper_databinding_1 = require("../helper-databinding");
const utils_2 = require("../utils");
const isBlockNode = (type) => type === 'BlockNode';
const isElementAndInGlobal = (type, name, options) => type === 'ElementNode' && (0, option_1.isGlobalComponent)(name, options);
function default_1(_, att, context) {
    context.mergeDatabindingVars(att.value);
    const ast = (0, helper_databinding_1.databindingForAttribute)(att.value);
    let attName = att.name;
    if (!att.value.hasBinding)
        return utils_1.babelTypes.jsxAttribute(utils_1.babelTypes.jsxIdentifier(attName), ast);
    if (ast &&
        (isElementAndInGlobal(_.type, _.name, context.options) ||
            isBlockNode(_.type))) {
        // 这种处理是为了解决 dataset传对象的问题
        ast.expression = utils_1.babelTypes.callExpression(utils_1.babelTypes.memberExpression(utils_1.babelTypes.identifier('$rm'), utils_1.babelTypes.identifier('toJsonString')), [
            (0, utils_2.getOptionalChainExpression)(ast.expression),
            utils_1.babelTypes.booleanLiteral(att.name.startsWith('data-'))
        ]);
    }
    else {
        // 自定义组件的属性，自动将- 转换成驼峰命名
        if (!att.name.startsWith('data-')) {
            attName = attName.replace(/[-\s]+(.)?/g, (m, w) => w ? w.toUpperCase() : '');
        }
        if (ast && ast.expression)
            ast.expression = (0, utils_2.getOptionalChainExpression)(ast.expression);
    }
    return utils_1.babelTypes.jsxAttribute(utils_1.babelTypes.jsxIdentifier(attName), ast);
}
exports.default = default_1;
//# sourceMappingURL=AttributeNode.js.map