"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasOwnProperty = exports.getExternalComponent = exports.isEnableSelectOwnerComponent = exports.isEnableStyleScope = exports.randomString = void 0;
// 生成随机字符串
function randomString(len = 32) {
    const $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678oOLl9gqVvUuI1';
    const maxPos = $chars.length;
    let pwd = '';
    for (let i = 0; i < len; i++) {
        pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
    }
    return pwd;
}
exports.randomString = randomString;
/**
 * 是否启用了样式隔离
 */
function isEnableStyleScope(options) {
    if (options.config && options.config.styleScope !== undefined) {
        return options.config.styleScope;
    }
    return options.appConfig.styleScope || options.styleScope;
}
exports.isEnableStyleScope = isEnableStyleScope;
function isEnableSelectOwnerComponent(options) {
    if (options.userConfig &&
        options.userConfig.web &&
        options.userConfig.web.appConfig &&
        typeof options.userConfig.web.appConfig.apis === 'object') {
        return !!options.userConfig.web.appConfig.apis.enableSelectOwnerComponent;
    }
    return false;
}
exports.isEnableSelectOwnerComponent = isEnableSelectOwnerComponent;
/**
 * 获取扩展组件
 */
function getExternalComponent(options, key) {
    const { externalComponents = {} } = options;
    return externalComponents[key] || '';
}
exports.getExternalComponent = getExternalComponent;
function hasOwnProperty(obj, property) {
    return Object.prototype.hasOwnProperty.call(obj, property);
}
exports.hasOwnProperty = hasOwnProperty;
//# sourceMappingURL=index.js.map